% This package provides a proper CD4Analysis highlighting based on the listings package
% The grammar for CD4Analysis can be found here: https://github.com/MontiCore/monticore/blob/master/monticore-generator/it/src/main/grammars/mc/lang/CD4Analysis.mc4

\NeedsTeXFormat{LaTeX2e}
\ProvidesPackage{cd4a-listings}[2019/05/19 CD4Analysis Listings]

\RequirePackage{listings}
\RequirePackage{atom-light-colors}


% code styles
\newcommand{\cdaKeywordStyle}{\color{atomPurple}\bfseries}
\newcommand{\cdaAssociationDirStyle}{\color{atomPurple}\bfseries}
\newcommand{\cdaStringStyle}{\color{atomGreen}\ttfamily}
\newcommand{\cdaCommentStyle}{\color{atomGrey}\ttfamily}
\newcommand{\cdaMultiLineCommentStyle}{\color{atomGrey}\ttfamily}
\newcommand{\cdaStereotypeStyle}{\color{atomBlue}\ttfamily}
\newcommand{\cdaMultiplicityStyle}{\color{atomBrown}\ttfamily\itshape}
\newcommand{\cdaDefaultTypeStyle}{\color{atomBrown}\ttfamily\itshape}

% language definition
\lstdefinelanguage{CD4A}{
    % java + cd keywords
    keywords={import,package,classdiagram,class,interface,enum,extends,implements,throws,association,composition,void},
    keywordstyle=\cdaKeywordStyle,
    % modifiers
    keywords=[2]{abstract,final,static,private,protected,public,derived},
    keywordstyle=[2]\cdaKeywordStyle,
    % modifier abbreviations
    keywords=[3]{-,+,\#,/},
    keywordstyle=[3]\cdaKeywordStyle,
    % % association directions
    keywords=[4]{<->,--,->,<-},
    keywordstyle=[4]\cdaKeywordStyle,
    % default types
    keywords=[5]{Char,String,Integer,Boolean,Long,Float,Double,Date,Time,DateTime,ZonedDateTime,UUID,byte,char,short,int,long,float,double,boolean,Optional},
    keywordstyle=[5]\cdaDefaultTypeStyle,
    %
    sensitive=true,
    alsoletter=:<-+\#/>,
    %
    % definition of comment style
    %
    morecomment=[l][\cdaCommentStyle]{//},
    morecomment=[s][\cdaMultiLineCommentStyle]{/*}{*/},
    morecomment=[s][\cdaStereotypeStyle]{<<}{>>}, % stereotypes
    commentstyle=\cdaCommentStyle,
    %
    % definition of string style
    %
    morestring=[s][\cdaStringStyle]{"}{"},
}
